blob: 464acb389bd531c56c3b4c5aa1b61339bf49fa34 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Alex Lightb55f1ac2016-04-12 15:50:55 -070049export SMALI_ARGS="--experimental"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Dan Willemsen12371e92017-03-06 17:55:20 -080081# OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP.
82# Convert it to an absolute path, since we cd into the tmp_dir to run the tests.
83export OUT_DIR=${OUT_DIR:-out}
84if [[ "$OUT_DIR" != /* ]]; then
85 export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR
86fi
87
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088# ANDROID_HOST_OUT is not set in a build environment.
89if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsen12371e92017-03-06 17:55:20 -080090 export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070091fi
92
Sebastien Hertz19ac0272015-02-24 17:39:50 +010093# If JACK_CLASSPATH is not set, assume it only contains core-libart.
94if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070095 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010096fi
97
Sebastien Hertz19ac0272015-02-24 17:39:50 +010098export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080099
Igor Murashkin271a0f82017-02-14 21:14:17 +0000100# Zipalign is not on the PATH in some configs, auto-detect it.
101if [ -z "$ZIPALIGN" ]; then
102 if which zipalign >/dev/null; then
103 ZIPALIGN="zipalign";
104 else
105 # TODO: Add a dependency for zipalign in Android.run-test.mk
106 # once it doesn't depend on libandroidfw (b/35246701)
107 case "$OSTYPE" in
108 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
109 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
110 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
111 esac
112 fi
113fi
114export ZIPALIGN
115
jeffhao5d1ac922011-09-29 17:41:15 -0700116info="info.txt"
117build="build"
118run="run"
119expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700120check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700121output="output.txt"
122build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100123cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700124strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700125lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700126testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700127run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000128build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700129
Alex Light91de25f2015-10-28 17:00:06 -0700130quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000131debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700132prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700133target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700134dev_mode="no"
135update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700136debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000137relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800138runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700139usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700140build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700141suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700142trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700143trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700144basic_verify="false"
145gc_verify="false"
146gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700147strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700148always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700149never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700150have_dex2oat="yes"
151have_patchoat="yes"
152have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800153multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000154android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700155bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800156suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700157# By default we will use optimizing.
158image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000159image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700160
161while true; do
162 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700163 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700164 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100165 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700166 shift
Alex Light91de25f2015-10-28 17:00:06 -0700167 elif [ "x$1" = "x--quiet" ]; then
168 quiet="yes"
169 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700170 elif [ "x$1" = "x--use-java-home" ]; then
171 if [ -n "${JAVA_HOME}" ]; then
172 export JAVA="${JAVA_HOME}/bin/java"
173 export JAVAC="${JAVA_HOME}/bin/javac -g"
174 else
175 echo "Passed --use-java-home without JAVA_HOME variable set!"
176 usage="yes"
177 fi
178 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800179 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700180 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800181 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800182 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700183 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700184 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700185 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100186 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100187 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700188 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700189 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800190 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700191 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700192 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700193 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700194 shift
195 elif [ "x$1" = "x--dalvik" ]; then
196 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800197 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700198 shift
Alex Light03a112d2014-08-25 13:25:56 -0700199 elif [ "x$1" = "x--no-dex2oat" ]; then
200 have_dex2oat="no"
201 shift
202 elif [ "x$1" = "x--no-patchoat" ]; then
203 have_patchoat="no"
204 shift
205 elif [ "x$1" = "x--no-image" ]; then
206 have_image="no"
207 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800208 elif [ "x$1" = "x--multi-image" ]; then
209 multi_image_suffix="-multi"
210 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700211 elif [ "x$1" = "x--pic-test" ]; then
212 run_args="${run_args} --pic-test"
213 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700214 elif [ "x$1" = "x--relocate" ]; then
215 relocate="yes"
216 shift
217 elif [ "x$1" = "x--no-relocate" ]; then
218 relocate="no"
219 shift
220 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100221 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700222 prebuild_mode="yes"
223 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700224 elif [ "x$1" = "x--strip-dex" ]; then
225 run_args="${run_args} --strip-dex"
226 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000227 elif [ "x$1" = "x--debuggable" ]; then
228 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000229 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000230 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700231 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100232 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700233 prebuild_mode="no"
234 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700235 elif [ "x$1" = "x--gcverify" ]; then
236 basic_verify="true"
237 gc_verify="true"
238 shift
239 elif [ "x$1" = "x--gcstress" ]; then
240 basic_verify="true"
241 gc_stress="true"
242 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800243 elif [ "x$1" = "x--suspend-timeout" ]; then
244 shift
245 suspend_timeout="$1"
246 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700247 elif [ "x$1" = "x--image" ]; then
248 shift
249 image="$1"
250 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700251 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000252 elif [ "x$1" = "x-Xcompiler-option" ]; then
253 shift
254 option="$1"
255 run_args="${run_args} -Xcompiler-option $option"
256 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000257 elif [ "x$1" = "x--build-option" ]; then
258 shift
259 option="$1"
260 build_args="${build_args} $option"
261 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700262 elif [ "x$1" = "x--runtime-option" ]; then
263 shift
264 option="$1"
265 run_args="${run_args} --runtime-option $option"
266 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700267 elif [ "x$1" = "x--gdb-arg" ]; then
268 shift
269 gdb_arg="$1"
270 run_args="${run_args} --gdb-arg $gdb_arg"
271 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700272 elif [ "x$1" = "x--debug" ]; then
273 run_args="${run_args} --debug"
274 shift
275 elif [ "x$1" = "x--gdb" ]; then
276 run_args="${run_args} --gdb"
277 dev_mode="yes"
278 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700279 elif [ "x$1" = "x--strace" ]; then
280 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700281 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700282 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700283 elif [ "x$1" = "x--zygote" ]; then
284 run_args="${run_args} --zygote"
285 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800286 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000287 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700288 image_suffix="-interpreter"
289 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800290 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700291 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000292 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800293 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700294 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700295 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800296 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700297 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700298 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700299 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700300 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700301 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700302 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700303 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700304 elif [ "x$1" = "x--no-optimize" ]; then
305 run_args="${run_args} --no-optimize"
306 shift
307 elif [ "x$1" = "x--no-precise" ]; then
308 run_args="${run_args} --no-precise"
309 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700310 elif [ "x$1" = "x--invoke-with" ]; then
311 shift
312 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700313 if [ "x$what" = "x" ]; then
314 echo "$0 missing argument to --invoke-with" 1>&2
315 usage="yes"
316 break
317 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700318 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700319 shift
320 elif [ "x$1" = "x--dev" ]; then
321 run_args="${run_args} --dev"
322 dev_mode="yes"
323 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700324 elif [ "x$1" = "x--build-only" ]; then
325 build_only="yes"
326 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100327 elif [ "x$1" = "x--build-with-javac-dx" ]; then
328 USE_JACK="false"
329 shift
330 elif [ "x$1" = "x--build-with-jack" ]; then
331 USE_JACK="true"
332 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700333 elif [ "x$1" = "x--output-path" ]; then
334 shift
335 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700336 if [ "x$tmp_dir" = "x" ]; then
337 echo "$0 missing argument to --output-path" 1>&2
338 usage="yes"
339 break
340 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700341 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000342 elif [ "x$1" = "x--android-root" ]; then
343 shift
344 if [ "x$1" = "x" ]; then
345 echo "$0 missing argument to --android-root" 1>&2
346 usage="yes"
347 break
348 fi
349 android_root="$1"
350 run_args="${run_args} --android-root $1"
351 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700352 elif [ "x$1" = "x--update" ]; then
353 update_mode="yes"
354 shift
355 elif [ "x$1" = "x--help" ]; then
356 usage="yes"
357 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700358 elif [ "x$1" = "x--64" ]; then
359 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700360 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700361 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200362 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700363 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200364 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700365 elif [ "x$1" = "x--stream" ]; then
366 trace_stream="true"
367 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700368 elif [ "x$1" = "x--always-clean" ]; then
369 always_clean="yes"
370 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700371 elif [ "x$1" = "x--never-clean" ]; then
372 never_clean="yes"
373 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800374 elif [ "x$1" = "x--dex2oat-swap" ]; then
375 run_args="${run_args} --dex2oat-swap"
376 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700377 elif [ "x$1" = "x--instruction-set-features" ]; then
378 shift
379 run_args="${run_args} --instruction-set-features $1"
380 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700381 elif [ "x$1" = "x--bisection-search" ]; then
382 bisection_search="yes"
383 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000384 elif [ "x$1" = "x--vdex" ]; then
385 run_args="${run_args} --vdex"
386 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000387 elif [ "x$1" = "x--vdex-filter" ]; then
388 shift
389 filter=$1
390 run_args="${run_args} --vdex-filter $filter"
391 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700392 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700393 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700394 usage="yes"
395 break
396 else
397 break
398 fi
399done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700400
Alex Light10bc5a42016-05-10 10:01:22 -0700401run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700402# Allocate file descriptor real_stderr and redirect it to the shell's error
403# output (fd 2).
404if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
405 exec {real_stderr}>&2
406else
407 # In bash before version 4.1 we need to do a manual search for free file
408 # descriptors.
409 FD=3
410 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
411 real_stderr=$FD
412 eval "exec ${real_stderr}>&2"
413fi
414if [ "$quiet" = "yes" ]; then
415 # Force the default standard output and error to go to /dev/null so we will
416 # not print them.
417 exec 1>/dev/null
418 exec 2>/dev/null
419fi
420
421function err_echo() {
422 echo "$@" 1>&${real_stderr}
423}
424
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700425# tmp_dir may be relative, resolve.
426#
427# Cannot use realpath, as it does not exist on Mac.
428# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700429# Cannot use readlink -m, as it does not exist on Mac.
430# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700431noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700432tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700433mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700434
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800435# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000436if [ ! "$runtime" = "jvm" ]; then
437 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
438fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800439
Alex Lighte7873ec2014-08-12 09:53:50 -0700440if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800441 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
442 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700443fi
444if [ "$gc_verify" = "true" ]; then
445 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
446fi
447if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700448 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700449fi
Jeff Hao85139a32014-07-23 11:52:52 -0700450if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700451 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
452 if [ "$trace_stream" = "true" ]; then
453 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
454 # the ability to analyze the file and just write to /dev/null.
455 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
456 # Enable streaming mode.
457 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
458 else
459 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
460 fi
461elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700462 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700463 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700464fi
465
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700466# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100467# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100468function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100469 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800470 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700471 if [ "x${suffix64}" = "x64" ]; then
472 target_arch_name=${grep64bit}
473 else
474 target_arch_name=${grep32bit}
475 fi
476}
477
David Brazdil853a4c32015-09-28 16:15:50 +0100478function guess_host_arch_name() {
479 if [ "x${suffix64}" = "x64" ]; then
480 host_arch_name="x86_64"
481 else
482 host_arch_name="x86"
483 fi
484}
485
Alex Lighta59dd802014-07-02 16:28:08 -0700486if [ "$target_mode" = "no" ]; then
487 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700488 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700489 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700490 exit 1;
491 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700492 fi
493fi
494
Alex Light03a112d2014-08-25 13:25:56 -0700495if [ "$have_patchoat" = "no" ]; then
496 run_args="${run_args} --no-patchoat"
497fi
498
499if [ "$have_dex2oat" = "no" ]; then
500 run_args="${run_args} --no-dex2oat"
501fi
502
Jeff Hao201803f2013-11-20 18:11:39 -0800503if [ ! "$runtime" = "jvm" ]; then
504 run_args="${run_args} --lib $lib"
505fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700506
Jeff Hao201803f2013-11-20 18:11:39 -0800507if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700508 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100509 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800510 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700511 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700512 else
513 true # defaults to using target BOOTCLASSPATH
514 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800515elif [ "$runtime" = "art" ]; then
516 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100517 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000518 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700519 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800520 else
David Brazdil853a4c32015-09-28 16:15:50 +0100521 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800522 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000523 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800524 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700525 if [ "$relocate" = "yes" ]; then
526 run_args="${run_args} --relocate"
527 else
528 run_args="${run_args} --no-relocate"
529 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700530elif [ "$runtime" = "jvm" ]; then
531 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800532 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700533fi
534
Alex Light03a112d2014-08-25 13:25:56 -0700535if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700536 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700537 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700538 exit 1
539 fi
Alex Light03a112d2014-08-25 13:25:56 -0700540 run_args="${run_args} --no-image"
541fi
542
jeffhao5d1ac922011-09-29 17:41:15 -0700543if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700544 err_echo "--dev and --update are mutually exclusive"
545 usage="yes"
546fi
547
548if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
549 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700550 usage="yes"
551fi
552
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700553if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
554 err_echo "--bisection-search and --prebuild are mutually exclusive"
555 usage="yes"
556fi
557
558if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
559 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
560 usage="yes"
561fi
562
563if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
564 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
565 usage="yes"
566fi
567
jeffhao5d1ac922011-09-29 17:41:15 -0700568if [ "$usage" = "no" ]; then
569 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
570 test_dir=`basename "$oldwd"`
571 else
572 test_dir="$1"
573 fi
574
575 if [ '!' -d "$test_dir" ]; then
576 td2=`echo ${test_dir}-*`
577 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700578 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700579 usage="yes"
580 fi
581 test_dir="$td2"
582 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700583 # Shift to get rid of the test name argument. The rest of the arguments
584 # will get passed to the test run.
585 shift
586fi
587
Søren Gjesse620d0a52016-09-19 11:12:51 +0200588# For building with javac and dx always use Java 7. The dx compiler
589# only support byte codes from Java 7 or earlier (class file major
590# version 51 or lower).
591if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
592 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
593fi
594
jeffhao5d1ac922011-09-29 17:41:15 -0700595if [ "$usage" = "yes" ]; then
596 prog=`basename $prog`
597 (
598 echo "usage:"
599 echo " $prog --help Print this message."
600 echo " $prog [options] [test-name] Run test normally."
601 echo " $prog --dev [options] [test-name] Development mode" \
602 "(dumps to stdout)."
603 echo " $prog --update [options] [test-name] Update mode" \
604 "(replaces expected.txt)."
605 echo ' Omitting the test name or specifying "-" will use the' \
606 "current directory."
607 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000608 echo " -O Run non-debug rather than debug build (off by default)."
609 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000610 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000611 echo " --runtime-option Pass an option to the runtime."
612 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000613 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000614 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700615 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000616 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200617 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
618 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000619 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800620 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000621 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000622 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700623 echo " --verify-soft-fail Force soft fail verification (off by default)."
624 echo " Verification is enabled if neither --no-verify"
625 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000626 echo " --no-optimize Turn off optimization (on by default)."
627 echo " --no-precise Turn off precise GC (on by default)."
628 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700629 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000630 echo " other runtime options are ignored."
631 echo " --no-dex2oat Run as though dex2oat was failing."
632 echo " --no-patchoat Run as though patchoat was failing."
633 echo " --prebuild Run dex2oat on the files before starting test. (default)"
634 echo " --no-prebuild Do not run dex2oat on the files before starting"
635 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700636 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000637 echo " --relocate Force the use of relocating in the test, making"
638 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000639 echo " address before running."
640 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700641 echo " --image Run the test using a precompiled boot image. (default)"
642 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000643 echo " --host Use the host-mode virtual machine."
644 echo " --invoke-with Pass --invoke-with option to runtime."
645 echo " --dalvik Use Dalvik (off by default)."
646 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700647 echo " --use-java-home Use the JAVA_HOME environment variable"
648 echo " to find the java compiler and runtime"
649 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000650 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700651 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000652 echo " --64 Run the test in 64-bit mode"
653 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700654 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700655 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000656 echo " --gcstress Run with gc stress testing"
657 echo " --gcverify Run with gc verification"
658 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700659 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000660 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000661 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700662 echo " --instruction-set-features [string]"
663 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800664 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
665 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700666 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700667 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700668 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000669 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800670 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Alex Light91de25f2015-10-28 17:00:06 -0700671 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700672 exit 1
673fi
674
675cd "$test_dir"
676test_dir=`pwd`
677
678td_info="${test_dir}/${info}"
679td_expected="${test_dir}/${expected}"
680
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700681if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700682 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700683 exit 1
684fi
685
686if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700687 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700688 exit 1
689fi
690
691# copy the test to a temp dir and run it
692
Elliott Hughes510c8782011-10-06 10:57:34 -0700693echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700694
695rm -rf "$tmp_dir"
696cp -Rp "$test_dir" "$tmp_dir"
697cd "$tmp_dir"
698
699if [ '!' -r "$build" ]; then
700 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800701else
702 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700703fi
704
705if [ '!' -r "$run" ]; then
706 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800707else
708 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700709fi
710
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700711if [ '!' -r "$check_cmd" ]; then
712 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800713else
714 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700715fi
716
jeffhao5d1ac922011-09-29 17:41:15 -0700717chmod 755 "$build"
718chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700719chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700720
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700721export TEST_NAME=`basename ${test_dir}`
722
Roland Levillain0d5a2812015-11-13 10:07:31 +0000723# arch_supports_read_barrier ARCH
724# -------------------------------
725# Return whether the Optimizing compiler has read barrier support for ARCH.
726function arch_supports_read_barrier() {
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000727 # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the
Roland Levillain0d5a2812015-11-13 10:07:31 +0000728 # moment.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000729 [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ]
Roland Levillain0d5a2812015-11-13 10:07:31 +0000730}
731
David Brazdil4846d132015-01-15 19:07:08 +0000732# Tests named '<number>-checker-*' will also have their CFGs verified with
733# Checker when compiled with Optimizing on host.
734if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000735 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
Roland Levillain0d5a2812015-11-13 10:07:31 +0000736 # Optimizing has read barrier support for certain architectures
737 # only. On other architectures, compiling is disabled when read
738 # barriers are enabled, meaning that we do not produce a CFG file
739 # as a side-effect of compilation, thus the Checker assertions
740 # cannot be checked. Disable Checker for those cases.
741 #
742 # TODO: Enable Checker when read barrier support is added to more
743 # architectures (b/12687968).
Hiroshi Yamauchifd3161a2017-01-18 14:47:25 -0800744 if [ "x$ART_USE_READ_BARRIER" != xfalse ] \
Roland Levillain0d5a2812015-11-13 10:07:31 +0000745 && (([ "x$host_mode" = "xyes" ] \
746 && ! arch_supports_read_barrier "$host_arch_name") \
747 || ([ "x$target_mode" = "xyes" ] \
748 && ! arch_supports_read_barrier "$target_arch_name")); then
749 run_checker="no"
David Brazdil80fb3942015-07-23 11:53:42 +0100750 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
751 # patchoat are available. Disable Checker otherwise (b/22552692).
Roland Levillain0d5a2812015-11-13 10:07:31 +0000752 elif [ "$prebuild_mode" = "yes" ] \
753 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100754 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100755
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100756 if [ "$target_mode" = "no" ]; then
757 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100758 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100759 else
760 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100761 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100762 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100763
764 if [ "$debuggable" = "yes" ]; then
765 checker_args="$checker_args --debuggable"
766 fi
767
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100768 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100769 -Xcompiler-option -j1"
770 fi
David Brazdil4846d132015-01-15 19:07:08 +0000771 fi
772fi
773
Mathieu Chartier031768a2015-08-27 10:25:02 -0700774 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700775
Ian Rogers997f0f92014-06-21 22:58:05 -0700776# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100777build_file_size_limit=2048
778run_file_size_limit=2048
Alex Light4694e822016-01-22 10:09:40 -0800779
780# Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with
781# large amounts of expected output or large generated files.
782if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100783 build_file_size_limit=5120
784 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700785fi
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100786if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then
787 # We will need to `adb pull` the .cfg output from the target onto the host to
788 # run checker on it. This file can be big.
Nicolas Geoffray4151eff2016-11-06 14:24:08 +0000789 build_file_size_limit=32768
790 run_file_size_limit=32768
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100791fi
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100792if [ ${USE_JACK} = "false" ]; then
793 # Set ulimit if we build with dx only, Jack can generate big temp files.
794 if ! ulimit -S "$build_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700795 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100796 fi
Ian Rogers997f0f92014-06-21 22:58:05 -0700797fi
798
jeffhao5d1ac922011-09-29 17:41:15 -0700799good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000800good_build="yes"
801good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700802if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000803 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700804 build_exit="$?"
805 echo "build exit status: $build_exit" 1>&2
806 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100807 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700808 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100809 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800810 echo "${test_dir}: running..." 1>&2
811 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700812 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000813
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800814 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000815 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100816 if [ "$target_mode" = "yes" ]; then
817 adb pull $cfg_output_dir/$cfg_output &> /dev/null
818 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100819 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000820 checker_exit="$?"
821 if [ "$checker_exit" = "0" ]; then
822 good="yes"
823 fi
Alex Light91de25f2015-10-28 17:00:06 -0700824 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000825 else
826 good="yes"
827 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800828 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000829 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700830 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700831elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000832 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700833 build_exit="$?"
834 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100835 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700836 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100837 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800838 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700839 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000840 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100841 if [ "$target_mode" = "yes" ]; then
842 adb pull $cfg_output_dir/$cfg_output &> /dev/null
843 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100844 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000845 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700846 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
847 good="yes"
848 else
Alex Light91de25f2015-10-28 17:00:06 -0700849 cat "$build_output" 1>&${real_stderr} 1>&2
850 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700851 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700852elif [ "$build_only" = "yes" ]; then
853 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000854 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700855 build_exit="$?"
856 if [ "$build_exit" '!=' '0' ]; then
857 cp "$build_output" "$output"
858 echo "build exit status: $build_exit" >>"$output"
859 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
860 if [ "$?" '!=' "0" ]; then
861 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700862 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700863 fi
864 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700865 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700866 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700867 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700868else
David Brazdil4846d132015-01-15 19:07:08 +0000869 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700870 build_exit="$?"
871 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100872 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700873 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100874 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800875 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700876 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000877 run_exit="$?"
878 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700879 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000880 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000881 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100882 if [ "$target_mode" = "yes" ]; then
883 adb pull $cfg_output_dir/$cfg_output &> /dev/null
884 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100885 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000886 checker_exit="$?"
887 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700888 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000889 good_run="no"
890 else
891 good_run="yes"
892 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000893 else
894 good_run="yes"
895 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700896 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000897 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700898 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700899 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
900 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700901 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700902 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700903 max_name_length=$(getconf NAME_MAX ${tmp_dir})
904 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
905 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700906 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700907 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700908 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700909 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000910 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
911 # output == expected
912 good="yes"
913 echo "${test_dir}: succeeded!" 1>&2
914 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700915 fi
916fi
917
jeffhao5d1ac922011-09-29 17:41:15 -0700918(
Alex Lightbfac14a2014-07-30 09:41:21 -0700919 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700920 echo "${test_dir}: FAILED!"
921 echo ' '
922 echo '#################### info'
923 cat "${td_info}" | sed 's/^/# /g'
924 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700925 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700926 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700927 if [ "$strace" = "yes" ]; then
928 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700929 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700930 echo '####################'
931 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700932 echo ' '
933 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700934
Alex Light91de25f2015-10-28 17:00:06 -0700935) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700936
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700937# Attempt bisection only if the test failed.
938if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
939 # Bisecting works by skipping different optimization passes which breaks checker assertions.
940 if [ "$run_checker" == "yes" ]; then
941 echo "${test_dir}: not bisecting, checker test." 1>&2
942 else
943 # Increase file size limit, bisection search can generate large logfiles.
944 if ! ulimit -S unlimited; then
945 err_echo "ulimit file size setting failed"
946 fi
947 echo "${test_dir}: bisecting..." 1>&2
948 cwd=`pwd`
949 maybe_device_mode=""
950 raw_cmd=""
951 if [ "$target_mode" = "yes" ]; then
952 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
953 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
954 # to exec in order to preserve pid when calling dalvikvm. This is required
955 # for bisection search to correctly retrieve logs from device.
956 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
957 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
958 maybe_device_mode="--device"
959 raw_cmd="$DEX_LOCATION/cmdline.sh"
960 else
961 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
962 fi
963 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
964 $maybe_device_mode \
965 --raw-cmd="$raw_cmd" \
966 --check-script="$cwd/check" \
967 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700968 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700969 --timeout=300
970 fi
971fi
972
Alex Lightbfac14a2014-07-30 09:41:21 -0700973# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700974if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700975 cd "$oldwd"
976 rm -rf "$tmp_dir"
977 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
978 adb shell rm -rf $DEX_LOCATION
979 fi
980 if [ "$good" = "yes" ]; then
981 exit 0
982 fi
983fi
984
985
986(
987 if [ "$always_clean" = "yes" ]; then
988 echo "${TEST_NAME} files deleted from host "
989 if [ "$target_mode" == "yes" ]; then
990 echo "and from target"
991 fi
992 else
993 echo "${TEST_NAME} files left in ${tmp_dir} on host"
994 if [ "$target_mode" == "yes" ]; then
995 echo "and in ${DEX_LOCATION} on target"
996 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700997 fi
998
Alex Light91de25f2015-10-28 17:00:06 -0700999) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001000
Alex Light6a870fa2016-05-31 16:36:19 -07001001if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1002 exit 0
1003else
1004 exit 1
1005fi